library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;
 

entity tbalu2 is
end tbalu2;

architecture tbbalu2 of tbalu2 is

component alu2 is
	port (clk,nw: in std_logic;
	din: in std_logic_vector(31 downto 0);
	op: in std_logic_vector( 2 downto 0);
	R: out std_logic_vector(63 downto 0);
	ready : out std_logic );
end component;

signal clk,nw,ready: std_logic;
signal din: std_logic_vector(31 downto 0);
signal op:  std_logic_vector( 2 downto 0);
signal R: std_logic_vector(63 downto 0);

begin
	
	du: alu2 port map (clk,nw,din,op,R,ready);
	
	
	process
	begin
		clk<='0';
		wait for 5 ns;
		clk<='1';
		wait for 5 ns;
   end process;
   
   nw <= '0' after 0 ns, '1' after 11 ns, '0' after 31 ns,
   						'1' after 71 ns, '0' after 91 ns,
                         '1' after 171 ns, '0' after 191 ns;
   
   din <= "00000000000001010000000000000010" after 11 ns,  --d0
          "00000000000000000000000000000010" after 71 ns,  --d0
          "00000000000000000000000000001010" after 91 ns,  --d1,
		  "00000000000000000000000000000110" after 171 ns,  --d0
          "00000000000000000000000000000011" after 191 ns,  --d1,
		  "00000000000000000000000000000110" after 201 ns;  --d2
   
   
   op <= "001" after 11 ns,  --addh
         "110" after 71 ns,  --mult
   		 "111" after 171 ns; --smult
   
end tbbalu2;
